<script setup lang="ts">
import { usePromotionStore } from '@/stores/promotion'
import { useProductStore } from '@/stores/product';
import { computed, onMounted, ref, watch } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Product } from '@/types/Product';
import type { PromotionDetail } from '@/types/PromotionDetail';
const textValidate = ref('')
const refform = ref<VForm | null>(null)
const promoStore = usePromotionStore()
const loading = ref(false)
const currentDate = new Date()
const productStore = useProductStore()

const productName = ref<string[]>([])
for (let index = 0; index < productStore.products.length; index++) {
  productName.value.push(productStore.products[index].name) 
}
const validatePositiveInteger = (v: number) => {
  if (v === null) return 'Field is required '
  const num = Number(v)
  return (
    (Number.isFinite(num) && num > 0 && num < 50) || 'A Number must be more than 0 and less than 1'
  )
}


async function save() {
  let { valid } = await refform.value!.validate()
  if (!valid) return
  if(promoStore.editedPromotion.id!){
    console.log(promoStore.product);
    
    for (let index = 0; index < promoStore.editedPromotion.promotionDetail.length; index++) {  
      const p = promoStore.product[index]
      if(p && p.id){
      promoStore.editedPromotion.promotionDetail[index].productName = p.name
      promoStore.editedPromotion.promotionDetail[index].productId = p.id
    }
    
    }
  }else{
    promoStore.editedPromotion.promotionDetail = []
    for(const j of promoStore.product){
      const p = productStore.products.find(item=>item.name === j.trim())
      console.log(p);
      if(p && p.id){
        promoStore.editedPromotionDetail = JSON.parse(JSON.stringify(promoStore.initPromotionDetail))
      let detail:PromotionDetail = promoStore.editedPromotionDetail
          detail.productId = p.id;
          detail.productName = p.name;
          detail.promoName = promoStore.editedPromotion.name
          promoStore.editedPromotion.promotionDetail.push(detail)
          console.log(detail);
          console.log(promoStore.editedPromotion.promotionDetail);
  }
    }
}
  console.log(promoStore.editedPromotion.promotionDetail);

  checkDateRange()
  condition()
  promoStore.save()
}

watch(['promoStore.editedPromotion.start', 'promoStore.editedPromotion.end'], checkDateRange)

function checkDateRange() {
  const startDate = new Date(promoStore.editedPromotion.start)
  const endDate = new Date(promoStore.editedPromotion.end)
  const startMonth = startDate.getMonth()
  const endMonth = endDate.getMonth()
  // ดูว่ามันได้รับข้อมูลเข้าไหม  
  console.log('Start Date:', startDate)
  console.log('End Date:', endDate)
  console.log('Start Month:', startMonth)
  console.log('End Month:', endMonth)

  promoStore.editedPromotion.status = currentDate >= startDate && currentDate <= endDate
  console.log('Status:', promoStore.editedPromotion.status)

  return promoStore.editedPromotion.status
}
function condition() {
  promoStore.editedPromotion.condition = ` ลดราคาเซ็ต ${promoStore.editedPromotion.promotionDetail.map((detail: PromotionDetail) => detail.productName).join(', ')} ${promoStore.editedPromotion.discount} บาท`
}

function isEnddateValid(endDate:Date){
  return new Date(endDate) > new Date(promoStore.editedPromotion.start) || 'End date must be after Start date';
}
function closeDialog(){
  promoStore.cleardialog()
  promoStore.dialogType2 = false
}
onMounted(()=>{
  productStore.getProducts()
  const item = productStore.products.map((detail: Product) => detail.name).join(', ');
  productName.value = item.split(', ')
})
</script>
<template>
  <v-dialog v-model="promoStore.dialogType2" persistent width="500">
    <v-card>
      <v-card-title>
        <span class="text-h5">Add Promotion</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refform" v-model="promoStore.form">
          <v-container>
            <v-row>
              <v-col cols="12" md="12">
                <v-text-field
                  v-model="promoStore.editedPromotion.name"
                  :rules="[(v) => !!v || 'Please enter name.']"
                  clearable
                  label="Name"
                  placeholder="Enter Promotion name"
                ></v-text-field>
              </v-col>
              <v-col cols="12" md="6">
                <v-text-field
                  v-model="promoStore.editedPromotion.start"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please enter start date.']"
                  clearable
                  label="Start Date"
                  type="date"
                ></v-text-field>
              </v-col>
              <v-col cols="12" md="6">
                <v-text-field
                  v-model="promoStore.editedPromotion.end"
                  :readonly="loading"
                  :rules="[isEnddateValid || 'Please enter end date.']"
                  clearable
                  label="End Date"
                  type="date"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="6">
                        <v-combobox
                          v-model="promoStore.product"
                          :items="productName"
                          label="product Name"
                          :return-object="false"
                          multiple
                        ></v-combobox>
                      </v-col>
              <v-col cols="12" md="6">
                <v-text-field
                  v-model="promoStore.editedPromotion.discount"
                  :readonly="loading"
                  :rules="[validatePositiveInteger]"
                  clearable
                  persistent-hint
                  label="Discount"
                  type="number"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="6" md="6">
                                     <v-img :src="'http://localhost:3000/images/promotions/' + promoStore.editedPromotion.image" width="200"></v-img>
                                </v-col>
                            
                            <v-col cols="12" sm="6" md="6">
                        <v-file-input 
                        v-model="promoStore.editedPromotion.files"
                        :rules="[
                          value => {
                            return !value || !value.length || value[0].size < 2000000 || 'Image size should be less than 2 MB!'
                          },
                        ]" accept="image/png, image/jpeg" placeholder="Pick an image" prepend-icon="mdi-camera"
                          label="Image"></v-file-input>
                      </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>{{ textValidate }}</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save()">
          Save
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
